#include<cstdio>
#include<algorithm>
#include<vector>
#include<queue>
using namespace std;
#define INF 1023456789

int R,S,r,s,M;
char v;
int vstup[3][2047][2047];
int dist[2047][2047];
int from[2047][2047];

int dy[] = {1,-1,0,0};
int dx[] = {0,0,1,-1};
char dc[] = "JSVZ";

int main(){
    scanf("%d %d %d %d %d", &R, &S, &r, &s, &M);
    //nacitanie vstupu a vyroba tabulky
    for(int i = 0; i<R; ++i)
        for(int j = 0; j<S; ++j){
            scanf(" %c", &v);
            vstup[0][i][j] = (v=='X')?1:0;
            dist[i][j] = INF;
        }
    int sum; 
    for(int i = R-1; i>=0; --i){
        for(int j = S-1; j>=0; --j){
            vstup[1][i][j] = vstup[1][i][j+1] + vstup[0][i][j]-((j+s<S)?vstup[0][i][j+s]:0);
            vstup[2][i][j] = vstup[2][i+1][j] + vstup[1][i][j]-((i+r<R)?vstup[1][i+r][j]:0);
        }
    }
    // BFS 
    queue<int> F;
    dist[0][0] = 0;
    F.push(0);
    F.push(0);
    int x,y, xx, yy;
    while(!F.empty()){
        y = F.front(); F.pop();
        x = F.front(); F.pop();
        if (y==R-r && x==S-s) {
            // zrekonstruovanie cesty
            vector<char> vc;
            while( y!=0 || x!=0 ){
                vc.push_back(dc[from[y][x]]);
                yy = y-dy[from[y][x]];
                x = x-dx[from[y][x]];
                y = yy;
            }            
            for(int i = vc.size()-1; i>=0; --i)
                printf("%c",vc[i]);
            printf("\n");
            return 0;
        }
        for(int d = 0; d<4; d++){
            yy = y+dy[d];
            xx = x+dx[d];
            // som mimo obyvacky, je tam vela prekazok alebo som tam uz bol
            if (xx<0 || yy<0 || xx>S-s || yy>R-r || 
                vstup[2][yy][xx]>M || dist[yy][xx]<=dist[y][x]+1) continue;

            dist[yy][xx] = dist[y][x]+1; 
            from[yy][xx] = d;
            F.push(yy);
            F.push(xx);
        }
    }
    printf("Santa je chudak.\n");

}
